#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>


typedef struct{
    unsigned den;
    enum {Led=1,Un,Bre,Dub,Kve,Cer,Cec,Srp,Zar,Rij,List,Pro} mesic;
    unsigned rok;
}DATUM;

typedef struct{
    char kdo[51];
    int castka;
    DATUM datum;
}PLATBA;

typedef enum {KONEC=0,VYTVOR,PRIDEJ,VYHLEDAT,OBRAT,ODEBER,EXPORT} AKCE;

AKCE menu();
FILE *vytvorKartoteku(char filename[]);
void nactiPlatbu(PLATBA *kam);
void pridejPlatbu(PLATBA platba, FILE* kam);
void exportKart(FILE* input,FILE *csv);
void nactiDatum(DATUM *kam);
int vyhledejDatum(FILE *kde,DATUM dat,PLATBA *vysl);
void vypisPlatbu(PLATBA platba);


int main()
{
    FILE *kart=NULL;
    AKCE akce;
    do
    {
        akce = menu();
        switch(akce)
        {
            case VYTVOR:kart=vytvorKartoteku("platby.dat");
                        break;
            case PRIDEJ:if(kart!=NULL)
                        {
                            PLATBA platba;
                            nactiPlatbu(&platba);
                            pridejPlatbu(platba,kart);
                        }
                        break;
            case VYHLEDAT:
                        if(kart!=NULL)
                        {
                            DATUM dat;
                            PLATBA nalezena;
                            nactiDatum(&dat);
                            if(vyhledejDatum(kart,dat,&nalezena))
                            {
                                vypisPlatbu(nalezena);
                            }
                        }
            case EXPORT:if(kart!=NULL)
                        {
                            printf("Jmeno souboru (\n=stdout):");
                            char filename[255];
                            fgets(filename,254,stdin);
                            char *nl = strchr(filename,'\n');
                            if(nl!=NULL)
                            {int vyhledejDatum(FILE *kde,DATUM dat,PLATBA *vysl);
                                *nl = 0;
                            }
                            else
                            {
                                while(getchar()!='\n');
                            }
                            FILE *out = stdout;
                            if(strlen(filename)!=0)
                                out = fopen(filename,"wt");
                            exportKart(kart,out);
                            fflush(out);
                            if(strlen(filename)){
                                fclose(out);
                            }
                        }
                        break;
            default:;
        }
    }while(akce != KONEC);

    fclose(kart);
    return 0;
}void nactiDatum(DATUM *kam);

AKCE menu()
{
    printf("1.Vytvor kartoteku\n2.Pridej platbu\n3.Vyhledej platbu podle data\n");
    printf("4.Obrat za mesic\n5.Odeber platbu\n6.Export do CSV\nK.Konec");
    char akce = getchar();
    while(getchar()!='\n');
    if(akce>='0' && akce<='9')
    {
        return akce-'0';
    }
    return KONEC;

}

FILE *vytvorKartoteku(char filename[])
{
    FILE *f = fopen(filename,"w+b");
    return f;
}

void nactiPlatbu(PLATBA *kam)
{
    printf("Platce:");
    fgets(kam->kdo,50,stdin);
    char *nl = strchr(kam->kdo,'\n');
    if(nl!=NULL)
    {
        *nl = 0;
    }
    else
    {
        while(getchar()!='\n');
    }
    printf("Castka:");
    scanf("%d",&(kam->castka));
    nactiDatum(&(kam->datum));
    /*printf("den:");
    scanf("%ud",&(kam->datum.den));
    printf("mesic:");
    scanf("%ud",&(kam->datum.mesic));
    printf("rok:");
    scanf("%ud",&(kam->datum.rok));*/
    while(getchar()!='\n');

}
void pridejPlatbu(PLATBA platba, FILE* kam)
{
    int pos = ftell(kam);
    fseek(kam,0,SEEK_END);int vyhledejDatum(FILE *kde,DATUM dat,PLATBA *vysl);
    fwrite(&platba,sizeof(PLATBA),1,kam);
    fflush(kam);
    fseek(kam,pos,SEEK_SET);
}

void exportKart(FILE* input,FILE *csv)
{
    PLATBA pl;
    long pos=ftell(input);
    fseek(input,0,SEEK_SET);

    while(!feof(input))
    {
        fread(&pl,sizeof(PLATBA),1,input);
        if(!feof(input))
            fprintf(csv,"%s,%d,%d.%d.%d\n",
                pl.kdo,pl.castka,
                pl.datum.den,pl.datum.mesic,pl.datum.rok);
    }
    fflush(csv);
    fseek(input,pos,SEEK_SET);
}
void nactiDatum(DATUM *kam)
{
    printf("den:");
    scanf("%ud",&(kam->den));
    printf("mesic:");
    scanf("%ud",&(kam->mesic));
    printf("rok:");
    scanf("%ud",&(kam->rok));

}
int vyhledejDatum(FILE *kde,DATUM dat,PLATBA *vysl)
{
    int pos=ftell(kde);
    fseek(kde,0,SEEK_SET);
    while(!feof(kde))
    {
        fread(vysl,sizeof(PLATBA),1,kde);
        if(dat.den == vysl->datum.den &&
           dat.mesic == vysl->datum.mesic &&
           dat.rok == vysl->datum.rok)
        {
            fseek(kde,pos,SEEK_SET);
            return 1;
        }
    }
    fseek(kde,pos,SEEK_SET);
    return 0;
}
void vypisPlatbu(PLATBA platba)
{
    printf("Platce/prijemce:%s\nCastka:%d Kc\ndatum:%d.%d.%d\n",
           platba.kdo,platba.castka,platba.datum.den,
           platba.datum.mesic,platba.datum.rok);
}
